﻿using Modèle;
using Persistance;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Business
{
    public class ManagerUsers
    {
        public ReadOnlyCollection<Personne> Utilisateurs { get; private set; }
        private List<Personne> utilisateurs = new List<Personne>();
        public Personne SelectedUser { get; set; }

        /// <summary>
        ///  DéPENDANCE
        /// </summary>

        public IPersistanceManager Pers { get; private set; }

        /// <summary>
        /// constructeur avec INJECTION DE LA DéPENDANCE
        /// </summary>

        public ManagerUsers(IPersistanceManager pers)
        {
            Utilisateurs = new ReadOnlyCollection<Utilisateur>(utilisateurs);
            Pers = pers;
        }
        public void LoadRequins()
        {
            utilisateurs.Clear();
            utilisateurs.AddRange(Pers.LoadUsers());
            if (utilisateurs.Count > 0)
            {
                SelectedUser = utilisateurs.First();
            }
        }

        public void SaveUsers()
        {
            Pers.SaveUsers(utilisateurs);
        }

        public bool AjouterUtilisateur(Utilisateur user)
        {
            if (utilisateurs.Contains(user))
            {
                return false;

            }
            utilisateurs.Add(user);
            return true;
        }

        public bool SupprimerUtilisateur(Utilisateur user)
        {
            if (!utilisateurs.Contains(user))
            {
                return false;
            }
            utilisateurs.Remove(user);
            return true;
        }

        public Utilisateur GetUtilisateur(Utilisateur user)
        {
            return utilisateurs.SingleOrDefault(r => r.Equals(user));
        }

        public bool ModifieUtilisateur(Utilisateur oldU, Utilisateur newU)
        {
            if (!oldU.Equals(newU))
            {
                return false;
            }
            utilisateurs.Remove(oldU);
            utilisateurs.Add(newU);
            return true;
        }


    }
}
